package com.miya.fastcashier.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.miya.fastcashier.beans.LoginRequest
import com.miya.fastcashier.beans.SelfCashierAccountInfo
import com.miya.fastcashier.service.BaseResult
import com.miya.fastcashier.service.LoginService
import kotlinx.coroutines.launch
import java.lang.RuntimeException

class LoginViewModel : ViewModel() {

    val loginLiveData: MutableLiveData<Result<BaseResult<SelfCashierAccountInfo>>> = MutableLiveData()

    fun login(userName:String,passWord:String) {
        viewModelScope.launch {
            val result = try {
                // 网络返回成功
                Result.success(LoginService.getApi().login(LoginRequest(userName,passWord,"")))
            } catch (e: Exception) {
                // 网络返回失败
                Result.failure(e)
            }
            // 注意这里是主线程，直接用setValue()即可
            loginLiveData.value = result
        }
    }

}